#ifndef __BUBSORT_H
#define __BUBSORT_H

#ifndef __SWAP_H
#include "swap.h"
#endif

/*
	Class C of the template allows for the use of different types
	of container classes, whilst T is the type actuall to be
	compared, the compare function is a ptr to function that
	the user creates to compare the types they are using, the
	compare function must return -1 if arg1 is less than arg2,
	0 if they are equal and 1 if arg1 is greater than arg2.
	The only thing is that class C (i.e. Vector< int > must be
	defined and equiped with the [] overloaded operators.
*/

template< class Size_t, class C, class T > void bubblesort( C& array,
Size_t size, signed int (*compare)( T t1, T t2 ) )
{
Size_t  n = size;

	for( Size_t i = 0; i < n - 1; i++ ) {
	   for( Size_t j = n - 1; i < j; j-- ) {
		if( compare( array[j], array[j - 1] ) < 0 )
			swap( array[j], array[j - 1] );
	    }
	}
}


#endif
