#ifndef	__EXCHSORT_H
#define __EXCHSORT_H

#ifndef __SWAP_H
#include "swap.h"
#endif

/*
	purpose: to sort a container of types T into a prioritised
		 order using the exchange sort algorithm.
		 The first arg is a reference to a container type
		 that has the overloaded operator [] built into it.
		 The second arg is the number of elements and
		 the third arg is the compare function, accepting
		 the types T to compare and returning, -1 if t1 < t2,
		 0 if t1 == t2 and 1 if t1 > t2.

	returns: void.
*/

template< class Size_t, class C, class T > void exchangesort( C& v,
Size_t size, signed int (*compare)( T t1, T t2 ) )
{
Size_t 	h, i, j;

	for( Size_t p = 0; p < size - 1; p++ ) {
	     h = p;
	       for( Size_t k = p + 1; k < size; k++ ) {
		  if( compare( v[k], v[h] ) < 0 )
			h = k;
	       }
	     if( p != h ) {
		i = h;
		j = p;
		swap( v[i], v[j] );
	     }
	}
}

#endif