	------------------------------------------------------------------
	-- Set up proper subdirectory structure for Euphoria files.     --
	-- This is run as part of the install process for euphor10.zip. --
	-- See readme.doc and install.doc.				--
	-- usage:  ex setupdir                                          --
	------------------------------------------------------------------

constant file_list = {
  {"DOC", 
   "ED.DOC", "HELP.E", "MINIMAN.DOC", "GOALS.DOC", "C.DOC", "BASIC.DOC"},

  {"DEMO",
   "PLOT3D.EX", "DICE.EX", "ANIMAL.EX", "MSET.EX", "ALLSORTS.EX",  
   "EXAMPLE.EX", "SB.EX", "SELECT.E", "TTT.EX", "SIMPLE.EX", "WIRE.EX",  
   "SANITY.EX", "GET.TST", "MOUSE.EX", "DEMO.DOC"},

  {"DEMO\\LEARN", 
   "LEARN.EX", "LEARN.DAT", "LEARN.DOC"},

  {"DEMO\\LANGWAR", 
   "WEAPONS.E", "SCREEN.E", "COMMANDS.E", "DAMAGE.E",  
   "DISPLAY.E", "EMOVE.E", "ENEMY.E", "SCHED.E", "VARS.E", "SOUNDEFF.E",  
   "LW.DOC", "LW.SUM", "LW.EX"},   

  {"DEMO\\BENCH", 
   "DATABASE.EX", "SIEVE.C", "SIEVE.BAS", "SHELL.EX",  
   "DATABASE.BAS", "DATABASE.C", "SHELL.BAS", "SHELL.C", "SIEVE.EX", 
   "FILESORT.EX", "DATABASE.PRO", "SIEVE.PRO", "SHELL.PRO",  
   "SHELL.PAS", "SIEVE.PAS", "BENCH.DOC"},
  
  {"INCLUDE", 
   "GRAPHICS.E", "SORT.E", "GET.E", "MOUSE.E"},  

  {"BIN", 
   "GREP.EX", "SYNCOLOR.E", "LINES.EX", "EPRINT.EX", "ED.BAT",  
   "GREP.BAT", "LINES.BAT", "GETNAMES.E", "DOS4GW.EXE", "EPRINT.BAT",  
   "RETAB.EX", "ED.EX", "INSTALL.EX", "EX.EXE", "BIN.DOC"},

  {"BIN\\PDOMAIN", "PD.DOC"}
}

procedure move(sequence source, sequence dest)
    sequence command

    command = "copy " & source & " " & dest
--  puts(1, command & '\n')
    system(command, 2) 
    
    command = "del " & source
--  puts(1, command & '\n')
    system(command, 2)
end procedure

procedure moveall()
    sequence command
    integer f

    f = open("bin\\ex.exe", "rb")
    if f != -1 then
	close(f)
	puts(1, "Subdirectory structure has been set up\n")
	return
    end if
    puts(1, "Creating Euphoria Subdirectories ...\n\n")
    for i = 1 to length(file_list) do
	command = "mkdir " & file_list[i][1]
	puts(1, command & '\n')
	system(command, 2) 
	for j = 2 to length(file_list[i]) do
	    move(file_list[i][j], file_list[i][1])
	end for
    end for
end procedure

moveall()


